//D3+React technique for loading data

import React, { useState, useCallback, useEffect } from 'react';
import ReactDom from 'react-dom';
import { csv } from 'd3';
import { dataMessage } from './message'

const width = 960;
const height = 500;
const colorCsvUrl='https://gist.githubusercontent.com/DavidAllyn68/060e51403b304b6b21b3ac5906e52921/raw/69a75c2be667683126b33af9bcc43cca4730eb19/css-colors-from-mozilla.csv';

const App = () => {
  const [data,setData] = useState(null);

  useEffect(()=>{
    //useEffect allows this code to run just once
    csv(colorCsvUrl).then(data => {
      //set the data in our state
      setData(data);
    });

  },[]);
  
  //then return the message based on our data
  return (
    <pre>{ data ? dataMessage(data) : 'Loading Data...'}</pre>
  );
};

// on our root element
const rootElement = document.getElementById('root');
// render the results of our App function
ReactDom.render(<App />, rootElement)
